<template>
  <div class="home--container" >
    <Header @keypress="handleInput" />
    <main>
      <ul>
        <Card
          v-for="serie in getCurrentSeries"
          :key="serie.id"
          :name="serie.name"
          :img="serie.image.medium"
          :ratingAverage="serie.rating.average"
          :scheduleDays="serie.schedule.days"
          :scheduleTime="serie.schedule.time"
          :runtime="serie.runtime"
          :serieId="serie.id"
          @click="handleClick"
        />
      </ul>
    </main>
    <Pagination
      @changePagintaion="handlePagination"
    />
  </div>
</template>

<script>
import { mapActions, mapGetters } from 'vuex'
import Card from '@/components/organisms/Card.vue'
import Header from '@/components/organisms/Header.vue'
import Pagination from '@/components/organisms/Pagination.vue'

export default {
  name: 'Index',
  components: {
    Card,
    Pagination,
    Header,
  },
  computed: {
    ...mapGetters([
      'getSeries',
      'getPaginationSize',
      'getCurrentNumberPage',
      'getCurrentSeries'
    ]),
  },
  methods: {
    ...mapActions([
      'allSeries',
      'querySeries',
      'changePage'
    ]),
    handleClick(ev) {
      this.$router.push(`/details/${ev}`)
    },
    handlePagination(ev) {
      ev === 'decrease'
        ? this.changePage(this.getCurrentNumberPage - 1)
        : this.changePage(this.getCurrentNumberPage + 1)
    },
    handleInput(ev) {
      console.log(ev)
      ev.length === 0
        ? this.allSeries()
        : this.querySeries(ev)
    }
  },
  created() {
    this.allSeries()
  }
}
</script>

<style lang="sass" scoped>
@import '../../shared/sass/index.sass'
.home--container
  background: $black
  overflow-y: auto
.home--container_search
  width: 350px
  height: 30px
  background: $gray
  border-radius: 20px
input
  padding: 7px 18px
  border: none
  outline: none
  width: 275px
  border-radius: 20px 0 0 20px
ul
  display: flex
  flex-flow: wrap
  justify-content: space-between
h1
  margin: 0
main
  width: 1150px
  margin: 0 auto
  min-height: calc( 100vh - 170px )
</style>
